# Revision

> Pontos: 200
> Resolução: Mayfly

```
> ... They aren’t necessarily obvious but are helpful to know.

http://git.ritsec.club:7000/Revision.git/

~knif3
```

```
> ... Eles não são necessariamente óbvios, mas ajuda saber.

http://git.ritsec.club:7000/Revision.git/

~knif3
```

## O Problema

Após baixar o repositório na máquina (`git clone http://git.ritsec.club:7000/Revision.git/`), a gente se de depara com um repositório normal.

Vendo os logs (`git log`) a gente encontra uma sequência estranha de commit começando do dia 6 de Fevereiro de 2019.

## A Resolução

Vendo esses logs melhor (`git log --oneline`):

```
88aaf37 TXkgZGVzaWduIGlzIGNvbXBsZXRlIQo=
68733d8 N2Q5ZDI1ZjcxY2I4YTVhYmE4NjIwMjU0MGEyMGQ0MDUK
b1a0dcb ZjRkNWQwYzA2NzFiZTIwMmJjMjQxODA3YzI0M2U4MGIK
4a2893a NjliNjQ2MjNmODZkZWYxNmNlMTdkNDU0YjhiZTQxYWUK
4963627 ODk3MzE2OTI5MTc2NDY0ZWJjOWFkMDg1ZjMxZTcyODQK
0f40e6e MmNkNmVlMmM3MGIwYmRlNTNmYmU2Y2FjM2M4YjhiYjEK
8e8ce11 OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
60f4e46 YjcyNjlmYTI1MDg1NDhlNDAzMmM0NTU4MThmMWUzMjEK
ee3d68b MzcyZTI1ZjIzYjVhOGFlMzNjN2JhMjAzNDEyYWNlMzAK
ebd4f62 ZjUzMDIzODY0NjRmOTUzZWQ1ODFlZGFjMDM1NTZlNTUK
53e3f77 OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
1849148 NmQ3ZmNlOWZlZTQ3MTE5NGFhOGI1YjZlNDcyNjdmMDMK
9d6d714 ZjRkNWQwYzA2NzFiZTIwMmJjMjQxODA3YzI0M2U4MGIK
eae1814 ODk3MzE2OTI5MTc2NDY0ZWJjOWFkMDg1ZjMxZTcyODQK
a2e1f5b MDFmYmRjNDRlZjgxOWRiNjI3M2JjMzA5NjVhMjM4MTQK
82b7ac8 YjcyNjlmYTI1MDg1NDhlNDAzMmM0NTU4MThmMWUzMjEK
1b07dd8 OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
c410e16 ZTI5MzExZjZmMWJmMWFmOTA3ZjllZjlmNDRiODMyOGIK
a4ee01c OWZmYmY0MzEyNmUzM2JlNTJjZDJiZjdlMDFkNjI3ZjkK
2e1c2e0 YjcyNjlmYTI1MDg1NDhlNDAzMmM0NTU4MThmMWUzMjEK
6fcc886 OWQ3YmYwNzUzNzI5MDhmNTVlMmQ5NDVjMzllMGE2MTMK
2a712b0 YjAyNjMyNGM2OTA0YjJhOWNiNGI4OGQ2ZDYxYzgxZDEK
58e54d7 NzJjZmQyNzJhY2UxNzJmYTM1MDI2NDQ1ZmJlZjliMDMK
d8ddbff MmNkNmVlMmM3MGIwYmRlNTNmYmU2Y2FjM2M4YjhiYjEK
432c9ee ZjRkNWQwYzA2NzFiZTIwMmJjMjQxODA3YzI0M2U4MGIK
f108cdb OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
9fe2c0e ZTg1ZGRlMzMwYzM0ZWZiMGU1MjZlZTMwODJlNDM1M2IK
50f69d6 ODk3MzE2OTI5MTc2NDY0ZWJjOWFkMDg1ZjMxZTcyODQK
6f621db MDA5NTIwMDUzYjAwMzg2ZDExNzNmMzk4OGM1NWQxOTIK
48297e0 OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
fca179e NmQ3ZmNlOWZlZTQ3MTE5NGFhOGI1YjZlNDcyNjdmMDMK
8aeb075 OWQ3YmYwNzUzNzI5MDhmNTVlMmQ5NDVjMzllMGE2MTMK
3abc63e ODk3MzE2OTI5MTc2NDY0ZWJjOWFkMDg1ZjMxZTcyODQK
5772320 MDFmYmRjNDRlZjgxOWRiNjI3M2JjMzA5NjVhMjM4MTQK
764794b OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
f23c832 MzJmOGUwYmI2OTQ0YTZlZmU4YjEzNTFiNzJiOGZhY2MK
331c43d ZDliZWQzYjdlMTUxZjExYjhmZGFkZjc1ZjFkYjk2ZDkK
2092ddb NjVkYjI3MzA3YWEwY2RmMGIzYzAzMjM0MzFlMDhhMTUK
2a769dd NDg1YmRiYWNlZmUyMjM0NGY2ZTc4Y2E1OGE2NjkyNDIK
```

E juntando eles:

```
TXkgZGVzaWduIGlzIGNvbXBsZXRlIQo=
N2Q5ZDI1ZjcxY2I4YTVhYmE4NjIwMjU0MGEyMGQ0MDUK
ZjRkNWQwYzA2NzFiZTIwMmJjMjQxODA3YzI0M2U4MGIK
NjliNjQ2MjNmODZkZWYxNmNlMTdkNDU0YjhiZTQxYWUK
ODk3MzE2OTI5MTc2NDY0ZWJjOWFkMDg1ZjMxZTcyODQK
MmNkNmVlMmM3MGIwYmRlNTNmYmU2Y2FjM2M4YjhiYjEK
OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
YjcyNjlmYTI1MDg1NDhlNDAzMmM0NTU4MThmMWUzMjEK
MzcyZTI1ZjIzYjVhOGFlMzNjN2JhMjAzNDEyYWNlMzAK
ZjUzMDIzODY0NjRmOTUzZWQ1ODFlZGFjMDM1NTZlNTUK
OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
NmQ3ZmNlOWZlZTQ3MTE5NGFhOGI1YjZlNDcyNjdmMDMK
ZjRkNWQwYzA2NzFiZTIwMmJjMjQxODA3YzI0M2U4MGIK
ODk3MzE2OTI5MTc2NDY0ZWJjOWFkMDg1ZjMxZTcyODQK
MDFmYmRjNDRlZjgxOWRiNjI3M2JjMzA5NjVhMjM4MTQK
YjcyNjlmYTI1MDg1NDhlNDAzMmM0NTU4MThmMWUzMjEK
OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
ZTI5MzExZjZmMWJmMWFmOTA3ZjllZjlmNDRiODMyOGIK
OWZmYmY0MzEyNmUzM2JlNTJjZDJiZjdlMDFkNjI3ZjkK
YjcyNjlmYTI1MDg1NDhlNDAzMmM0NTU4MThmMWUzMjEK
OWQ3YmYwNzUzNzI5MDhmNTVlMmQ5NDVjMzllMGE2MTMK
YjAyNjMyNGM2OTA0YjJhOWNiNGI4OGQ2ZDYxYzgxZDEK
NzJjZmQyNzJhY2UxNzJmYTM1MDI2NDQ1ZmJlZjliMDMK
MmNkNmVlMmM3MGIwYmRlNTNmYmU2Y2FjM2M4YjhiYjEK
ZjRkNWQwYzA2NzFiZTIwMmJjMjQxODA3YzI0M2U4MGIK
OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
ZTg1ZGRlMzMwYzM0ZWZiMGU1MjZlZTMwODJlNDM1M2IK
ODk3MzE2OTI5MTc2NDY0ZWJjOWFkMDg1ZjMxZTcyODQK
MDA5NTIwMDUzYjAwMzg2ZDExNzNmMzk4OGM1NWQxOTIK
OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
NmQ3ZmNlOWZlZTQ3MTE5NGFhOGI1YjZlNDcyNjdmMDMK
OWQ3YmYwNzUzNzI5MDhmNTVlMmQ5NDVjMzllMGE2MTMK
ODk3MzE2OTI5MTc2NDY0ZWJjOWFkMDg1ZjMxZTcyODQK
MDFmYmRjNDRlZjgxOWRiNjI3M2JjMzA5NjVhMjM4MTQK
OTI1MjBhNWE5Y2Y4OTMyMjBiOWNkNDQ3ZjU4NWYxNDQK
MzJmOGUwYmI2OTQ0YTZlZmU4YjEzNTFiNzJiOGZhY2MK
ZDliZWQzYjdlMTUxZjExYjhmZGFkZjc1ZjFkYjk2ZDkK
NjVkYjI3MzA3YWEwY2RmMGIzYzAzMjM0MzFlMDhhMTUK
NDg1YmRiYWNlZmUyMjM0NGY2ZTc4Y2E1OGE2NjkyNDIK
```

É formado o que parece ser uma mensagem codificada em Base 64 (pelos caracteres usados e os '='), mas o '=' fica no final, então invertemos a ordem das linhas e decodificando a base64, temos um outro texto, mas dessa vez com uma mensagem em baixo.

```bash
echo $MENSAGEM | tac | base64 -d
```

Output:

```
485bdbacefe22344f6e78ca58a669242
65db27307aa0cdf0b3c0323431e08a15
d9bed3b7e151f11b8fdadf75f1db96d9
32f8e0bb6944a6efe8b1351b72b8facc
92520a5a9cf893220b9cd447f585f144
01fbdc44ef819db6273bc30965a23814
897316929176464ebc9ad085f31e7284
9d7bf075372908f55e2d945c39e0a613
6d7fce9fee471194aa8b5b6e47267f03
92520a5a9cf893220b9cd447f585f144
009520053b00386d1173f3988c55d192
897316929176464ebc9ad085f31e7284
e85dde330c34efb0e526ee3082e4353b
92520a5a9cf893220b9cd447f585f144
f4d5d0c0671be202bc241807c243e80b
2cd6ee2c70b0bde53fbe6cac3c8b8bb1
72cfd272ace172fa35026445fbef9b03
b026324c6904b2a9cb4b88d6d61c81d1
9d7bf075372908f55e2d945c39e0a613
b7269fa2508548e4032c455818f1e321
9ffbf43126e33be52cd2bf7e01d627f9
e29311f6f1bf1af907f9ef9f44b8328b
92520a5a9cf893220b9cd447f585f144
b7269fa2508548e4032c455818f1e321
01fbdc44ef819db6273bc30965a23814
897316929176464ebc9ad085f31e7284
f4d5d0c0671be202bc241807c243e80b
6d7fce9fee471194aa8b5b6e47267f03
92520a5a9cf893220b9cd447f585f144
f5302386464f953ed581edac03556e55
372e25f23b5a8ae33c7ba203412ace30
b7269fa2508548e4032c455818f1e321
92520a5a9cf893220b9cd447f585f144
2cd6ee2c70b0bde53fbe6cac3c8b8bb1
897316929176464ebc9ad085f31e7284
69b64623f86def16ce17d454b8be41ae
f4d5d0c0671be202bc241807c243e80b
7d9d25f71cb8a5aba86202540a20d405
My design is complete!
```

Vimos que as linhas eram hashes.

```bash
# Testando com a primeira linha da saída
hashid '485bdbacefe22344f6e78ca58a669242'
```

Output:

```
Analyzing '485bdbacefe22344f6e78ca58a669242'
[+] MD2
[+] MD5 <- O que a gente quer
[+] MD4
[+] Double MD5
[+] LM
[+] RIPEMD-128
[+] Haval-128
[+] Tiger-128
[+] Skein-256(128)
[+] Skein-512(128)
[+] Lotus Notes/Domino 5
[+] Skype
[+] Snefru-128
[+] NTLM
[+] Domain Cached Credentials
[+] Domain Cached Credentials 2
[+] DNSSEC(NSEC3)
[+] RAdmin v2.x
```

Descobrimos depois que cada um desses hashes representa um dos caracteres da flag assim:

```bash
echo R | md5sum
```

Output:

```
485bdbacefe22344f6e78ca58a669242  -
```

Que bate com a primeira linha dos hashes que pegamos. Após rodarmos um script em bash:

```bash
for HASH in $MENSAGEM_DECODIFICADA
do
	for C in {{a..z},{A..Z},{0-9},_}
	do
		RES=$(echo $C | md5sum | awk '{ print $1 }')
		if [ "$RES" == "$HASH" ]
		then
			echo $C
		fi
	done
done
```

Output:

```
R
S
I
_
h
0
p
3
_
y
0
u
_
s
c
r
1
p
t
e
d
_
t
h
0
s
3
_
g
i
t
_
c
0
m
s
```

Obtivemos a flag.

```
RS{I_h0p3_y0u_scr1pted_th0s3_git_c0ms}
```

